# STL Deque

---

* Pronounced “deck”, short for “double-ended-queue”.
* They are sequence containers with dynamic sizes that can be expanded or contracted on both ends.
* Similar to Vectors but not guaranteed to be contiguous in memory as well as the ability to insert and delete elements at the beginning of the sequence and not only at it's end. 

```cpp
#include <iostream>
#include <deque> // Import for std::deque


int main()
{
    std::deque<int> queue;
    for (auto i = 0U; i < 10; ++i)
    {
        queue.push_front(i*i);
    }


    while (queue.size() > 0)
    {
        std::cout << queue.back() << "\n";

        queue.pop_back();
    }

    return 0;
}
```

---

#### front\(\), push\_front\(\), and pop\_front\(\)

**.front\(\)** – retrieves an element from the front of the list.

**.push\_front\(\)** - Pushes an element to the front of the list.

**.pop\_front\(\)** – pops an element from the front of the list and deletes it.

```cpp
std::deque<int> queue;
for (auto i = 0U; i < 10; ++i)
{
    queue.push_front(i*i);
    std::cout << "Current front: " << queue.front() << std::endl;
}

/*
OUTPUT
Current front: 0
Current front: 1
Current front: 4
Current front: 9
Current front: 16
Current front: 25
Current front: 36
Current front: 49
Current front: 64
Current front: 81
*/
```

```cpp
// Continue from above
std::cout << "\n\nPOPPING" << std::endl;

for (auto i = 0U; i < 10; ++i)
{
    std::cout << "Popping: " << queue.front() << std::endl;
    queue.pop_front();
}

/*
OUTPUT:
POPPING
Popping: 81
Popping: 64
Popping: 49
Popping: 36
Popping: 25
Popping: 16
Popping: 9
Popping: 4
Popping: 1
Popping: 0
*/
```

---

#### back\(\), push\_back, and pop\_back\(\)

**.back\(\)** – retrieves an element from the end of the list.

**.push\_back\(\) **– inserts an element at the end of the list.

**.pop\_back\(\)** – removes an element from the end of the list and deletes it.

```cpp
std::deque<int> queue;

for (auto i = 0U; i < 10; ++i)
{
	queue.push_back(i*i);
}

for (auto i = 0U; i< 10; ++i)
{
	std::cout << queue.back() << "\t";
	queue.pop_back();
}
```

---



